/*
 *  calmosaic - v2.1.0
 *  jQuery plugin to create github like contributions timeline
 *  https://github.com/routekick/calmosaic
 *
 *  Made by Routekick
 *  Under MIT License
 */

!function(M){"use strict";var n="calmosaic",a={title:null,months:12,lastMonth:moment().month()+1,lastYear:moment().year(),coloring:null,labels:{days:!1,months:!0,custom:{weekDayLabels:null,monthLabels:null}},legend:{show:!0,align:"right",minLabel:"Less",maxLabel:"More"}};function s(t,e,s){this.element=t,this.data=e,this.settings=M.extend(!0,{},a,s),this._defaults=a,this._name=n,this.init()}M.extend(s.prototype,{init:function(){this.calendarHeatmap(),moment||console.log("The calmosaic plugin requires moment.js")},parse:function(){var t=M.type(this.data);if(-1===["array","object"].indexOf(t))return console.log("Invalid data source"),null;if("array"===t&&0<this.data.length){var e=M.type(this.data[0]);if("object"===e)return this.data[0].date&&this.data[0].count?this.data.slice(0):null;if(-1<["string","date"].indexOf(e)){if(moment(this.data[0]).isValid()){var s={};for(var n in this.data){var a=moment(this.data[n]).format("YYYY-MM-DD");s[a]?s[a]+=1:s[a]=1}var i=[];for(var l in s)i.push({count:s[l],date:l});return i}return null}return null}if("array"===t&&0===this.data.length)return[];if("object"!==t||Object.empty(this.data))return null;var h=Object.keys(this.data);if(!moment(h[0]).isValid())return null;if("number"===M.type(this.data[h[0]])){var r=[];for(var o in this.data)r.push({count:this.data[o],date:moment(o).format("YYYY-MM-DD")});return r}},index:function(t){for(var e in this.idx={},t)this.idx[t[e].date]=e},pad:function(t,e){return(t=String(t)).length<e?this.pad("0"+t,e):t},calculateBins:function(t){var e,s=[],n=this.settings.steps||4,a=["0"],i=[[0,0]];for(e in t)t[e].count=parseInt(t[e].count),s.push(t[e].count);var l=Math.min.apply(Math,s),h=Math.max.apply(Math,s),r=(h-l)/n;for(0===r&&(r=h/n)<1&&(r=1),e=0;e<n;e++)if(isFinite(l))if(h<n)0<=e-(n-h)?(a.push(String(e-(n-h)+1)),i.push([e-(n-h)+1,e-(n-h)+1])):(a.push(""),i.push([null,null]));else if(h===n)a.push(String(e+1)),i.push([e+1,e+1]);else if(h-2===n)e+1===n?(a.push(String(e+1)+"+"),i.push([e+1,null])):(a.push(String(e+1)),i.push([e+1,e+1]));else{var o=Math.round(e*r)+1,u=Math.round(e*r+r);i.push([o,u]),e===n-1?o+="+":o!==u&&(o+=" to ",o+=u),a.push(String(o))}else a.push(""),i.push([null,null]);for(e in t)0===t[e].count?t[e].level=0:t[e].count-l==0?t[e].level=1:isFinite(l)?t[e].level=this.matchBin(i,t[e].count):t[e].level=n;return{events:t,bins:a}},matchBin:function(t,e){for(var s in t)if(e>=t[s][0]&&e<=t[s][1])return s;return 0},matchDate:function(t,e){return this.idx[e]?t[this.idx[e]]:null},calendarHeatmap:function(){var t=this.parse();if("array"===M.type(t)){this.index(t);var e,s=this.calculateBins(t),n=s.events,a=s.bins,i=this.settings.lastMonth,l=this.settings.lastYear,h=this.settings.months;M(this.element).empty(),this.settings.title&&M("<h3>",{class:"ch-title",html:this.settings.title}).appendTo(M(this.element));var r=M("<div class='ch-graph' />"),o=M("<ul class='ch-months' />"),u=M("<ul class='ch-days'></ul>");for(r.append(o),r.append(u),M(this.element).append(r),e=h;0<e;e--){var d=i-e,c=l;d<0&&(c-=1,d+=12);var m=moment().set({month:d,year:c}).format("MMM");this.settings.labels.custom.monthLabels&&(m="array"===M.type(this.settings.labels.custom.monthLabels)?this.settings.labels.custom.monthLabels[d]||"":moment().set({month:d,year:c}).format(this.settings.labels.custom.monthLabels)),o.append("<li>"+m+"</li>");for(var p=moment().set({month:d,year:c}).daysInMonth(),g=0;g<p;g++){var f=c+"-"+this.pad(d+1,2);f+="-"+this.pad(g+1,2);var v=this.matchDate(n,f);if(v){var y=v.count+" on ";y+=moment(v.date).format("ll");var b="";this.settings.coloring&&(b=" "+this.settings.coloring+"-"+v.level),M("<li/>",{class:"ch-day lvl-"+v.level+b,title:y}).appendTo(u)}else M("<li/>",{class:"ch-day"}).appendTo(u)}}if(this.settings.legend.show)for(M("<div>",{class:"ch-legend"}).appendTo(r).append("<small>"+(this.settings.legend.minLabel||"")+"</small>").append('<ul class="ch-lvls"></ul>').append("<small>"+(this.settings.legend.maxLabel||"")+"</small>"),"left"===this.settings.legend.align&&M(".ch-legend",this.element).addClass("ch-legend-left"),"center"===this.settings.legend.align&&M(".ch-legend",this.element).addClass("ch-legend-center"),e=0;e<a.length;e++)M("<li>",{class:"ch-lvl lvl-"+e,title:a[e],"data-toggle":"tooltip"}).appendTo(M(".ch-lvls",this.element)),this.settings.coloring&&M(".ch-lvls li:last",this.element).addClass(this.settings.coloring+"-"+e)}}}),M.fn[n]=function(t,e){return this.each(function(){M.data(this,"plugin_"+n)||M.data(this,"plugin_"+n,new s(this,t,e))})}}(jQuery);